#include "DMRPTrooper.hpp"
#include <algorithm>

struct ClActAscFunctor {
	bool operator() (const std::pair<SharedClause*,uint32_t>& a, const std::pair<SharedClause*,uint32_t>& b){
	    return a.second < b.second;}
};


void 	DMRPTrooper::clearAssignsCareForHooks(){

	if(decisionLevel() == 0){ return;}

	vector<std::pair<Literal, ClsPointer > > link_later;
	const uint32_t assign_idx = decision_level_end[0]; asrt(assign_stack.size() >= assign_idx);

	queue_begin 	= assign_stack.size();


	while(queue_begin != assign_idx ){
		Literal lit 	= assign_stack[--queue_begin];
		Variable x  	= lit.toVar();
		const bool hkd 	= isRefPoint(lit);
		setRefPoint(lit);
		sstate.vinf			.varClearValue(x);
		decision		->restoreVar(x);

		if(!hkd){aux_var(uint32_t c=)
			findNewHookResponsibles(x,link_later); asrt(c==0);
			hook_resp	.clear(x);
		}

	}


	assign_stack		.resize(queue_begin); asrt(beyUP_cands.empty()); asrt(beyUP_head== 0);
	decision_level_end	.clear();
	sstate.stats->sum_bcktrk 	+= decisionLevel();

	for(uint i = 0; i != link_later.size();++i){
		asrt(isRefPoint(link_later[i].first));
		hook_resp.add(link_later[i].first.toVar(), link_later[i].second);
	}
	sanity(asrtAllWatchedAlsoHooked());
}

Literal DMRPTrooper::findHookRespons(SharedClause* cls, uint32_t& sz_out)const{

	sz_out 			= 0;
	FOR_LITS_STRT(cls,lit);
		++sz_out;
		if(!sstate.vinf.litFalse(lit) && isRefPoint(lit)){
			sz_out = max32;
			return lit;}

		if(sstate.vinf.litTrue(lit)){ asrt(!isRefPoint(lit));
			sz_out = max32;
			return lit;}

	FOR_LITS_END;

	return INVALID_LIT;
}


uint32_t    DMRPTrooper::findNewHookResponsibles(const Variable& v, vector<std::pair<Literal,ClsPointer> >& link_later){

	uint32_t not_found = 0;
	Iter<ClsPointer> iter = hook_resp.getIter(v); ClsPointer clp;

	while(iter.getNext(clp)){
		SharedClause* cls 	= sstate.cinf.get(clp).getCls();
		uint32_t csz		= 0;

		FOR_LITS_STRT(cls,lit);
			++csz;
			if(!sstate.vinf.litFalse(lit) && isRefPoint(lit)){
				hook_resp.add(lit.toVar(),clp);
				goto CONTINUE_NEXT_CLS;
			}

			if(sstate.vinf.litTrue(lit)){
				assert(!isRefPoint(lit));
				link_later.push_back(std::pair<Literal,ClsPointer>(lit,clp)); //the list of clauses "belongs" to -lit up to now! That's why we have to link later
				goto CONTINUE_NEXT_CLS;
			}

		FOR_LITS_END;


		//unlink clause by replacing actual one by a satisfiable dummy, already marked as waste
		//this is done because we don't know the two watchers of cls at the moment
		++not_found;{
		SharedClause* repl 	= SharedClause::cloneSatDummyFrom(UserMask(sstate.s_info->user_bit),cls,csz);
		sstate.cinf				.replaceShared(clp,repl,1);
		addClsUnlinked(cls,true);}

		CONTINUE_NEXT_CLS: ;
	}

	hook_resp.clear(v);
	return not_found;
}





TrBool	DMRPTrooper::computeNewHooks(){

	asrt(ok()); LOG2("Compute new Hooks"); asrt(decisionLevel()==0);
	if(bcpLong() != BCP_SUCCESS){return TrBool(setInvalid("Propagation at level 0"));}

	newDecisionLevel();
	TrBool status = UNKNOWN_TrBool;
	while(restarts.shallRun()){
		asrt(decisionLevel()==1);
		Variable nextv	= decision->decideVar();

		if (nextv == INVALID_VAR){status=TRUE_TrBool; break;}

		Literal next	= sstate.s_info->getMayorValue(nextv);
						asrt(!sstate.vinf.litRepl(next)); asrt(!sstate.vinf.varElim(nextv)); asrt(sstate.vinf.litUkwn(next));

		if(!enqueue(next,decisionLevel())){
			backjumpKeepLevel(0);
			if(!enqueue(next.flipped(),0) || bcpLong()!= BCP_SUCCESS){
				return TrBool(setInvalid("Contradicting decision whlie searching for binary model"));}
			newDecisionLevel();
		}
	}

	backjumpKeepLevel(0); asrt(!openBCPImpls());
	sendUnits();

	if(status != TRUE_TrBool) return status;

	for(uint32_t v =nVars();v--;){Variable var(v);
		setRefPoint(var,sstate.vinf.varPrevValWasTrue(var));}

	return status;
}

void	DMRPTrooper::unlinkUnhookedClauses(){
	asrt(decisionLevel()==0);asrt(beyUP_cands.empty());asrt(unlinked_clses.empty());

	sendUnits();

	sanity(sstate.wtch.asrtBinsBothDirs(sstate.vinf)); LOG2("Unlink unhooked clauses");
	for(uint32_t w=0;w!=sstate.stats->nVariables(); ++w){
		const Variable v(w);
		if(sstate.vinf.varElim(v)|| sstate.vinf.varRepl(v)) continue;
		unlinkUnhookedOf(v.toNegLit());
		unlinkUnhookedOf(v.toPosLit());
	}
	LOG1("Finish unlinking of unhooked " << unlinked_clses.size()); sanity(sstate.wtch.asrtBinsBothDirs(sstate.vinf));
	sanity(asrtNumberHookResponsiblesAllRight()); sanity(asrtAllWatchedAlsoHooked());
}


void DMRPTrooper::unlinkUnhookedOf( const Literal& lit){
	LOG3("Unlink Watchers of literal "<<lit.toDIMACS()); asrt(decisionLevel()==0);

	WtchEle we; uint32_t sz;
	WIter<WtchEle> wi	= sstate.wtch.getWtchOfW(lit);

	while(wi.getNext(we)){
		ClsWrp& cw			= sstate.cinf.get(we.clp);
		we.other 			= cw.getOtherW(lit);
		SharedClause* cls 	= cw.getCls();

		if(we.other ==lit){	//already handled and marked for unlinking
			addClsUnlinked(cls,true);
			sstate.cinf			.freePtrOnly(we.clp,cw.getOffset());
			continue;}

		if(we.other < lit){ //already handled and added to respons list
			wi.keep(we);
			continue;}

		asrt(lit < we.other); //we have to check for unlinking

		sz = max32;
		Literal resp 	= (sstate.vinf.litFalse(lit)||sstate.vinf.litFalse(we.other)) ? INVALID_LIT :
							(isRefPoint(lit) ? lit :
							(isRefPoint(we.other)?we.other:
							findHookRespons(cw.getCls(),sz)));

		if(resp != INVALID_LIT){
			hook_resp.add(resp.toVar(),we.clp);
			wi.keep(we);
		}else{
			cw.invalidateWatchers();//mark cls for unlinking
			cw.setOffset(sz == max32 ? cls->countLits() : sz);
		}
	}
	sstate.wtch.finish(lit,wi);
}







TrBool 	DMRPTrooper::isSat(){
	LOG1("random freq " << super::decision->getRandFreq());
	LOG1("Timeout " << timeout);
	LOG1("restart init " << restarts.getInitialNumber());
	LOG1("bump_glue" << super::bump_glue);


	if(!super::ok())		return FALSE_TrBool;
	super::decision			->validateNbrVariables(super::sstate.stats->nVariables());
	super::sstate.stats->init_time = Satistics::cpuWallTime();

	TrBool  status	= UNKNOWN_TrBool;

	while(Satistics::cpuWallTime() <= timeout){

		LOG2("CPU User Time: "<< cpuUsrTime() << " [sec]");
		++super::sstate.stats->nbr_starts;

		TrBool new_hook_stat = computeNewHooks();

		if(!new_hook_stat.isTrue()){ return new_hook_stat;}

		unlinkUnhookedClauses(); asrt(asrtAllUnitsSent());


		status		= dmrpSolve();
					  asrt(decisionLevel()==0); sanity(status.isFalse() || asrtAllWatchedAlsoHooked());

		if(status.isTrue()){
			for(uint32_t v=nVars();v--;){Variable var(v);
				if(!sstate.varReplFixOrElim(var)){
					sstate.vinf.setValueDecision(getRefPoint(var),0);}
		}}

		if(status.isKnown()|| !restarts.shallRun()){return status;}

		uint32_t learnts_allow = conflicts.shallDoGC(sstate.stats->nLearntLongClses(),sstate.stats->nLits());
		if(learnts_allow == max32){
			clearWatches(max32);
			sstate.stats->nbr_simplify++;
		}else{
			clsGC(learnts_allow );
			conflicts.didGC(sstate.stats->nLearntLongClses());
		}

		if(!relinkUnhookedClauses() ||	!import() || (bcpLong()!=BCP_SUCCESS)){
			return TrBool(setInvalid("import in main loop"));}

	}

	return status;
}




bool DMRPTrooper::relinkUnhookedClauses(){
	hook_resp	.clearAllEles();
	sendUnits();

	act_t dummy_threash(0);
	for(std::list<std::pair<SharedClause*,uint32_t> >::iterator iter = unlinked_clses.begin(); iter != unlinked_clses.end();++iter){
		SharedClause* cls = iter->first;	LOG2("Reimport cls " << ((uint64_t)cls));

		if(!imprtLong(cls,max32,100,dummy_threash)){
			LOG1("Clause " << ((uint64_t)cls) << " is unsat while relinking unhooked");
			return setInvalid("Relink Unhooked clauses");}
	}
	unlinked_clses.clear();
	return true;
}






TrBool  DMRPTrooper::dmrpSolve(){
	sanity(asrtNumberHookResponsiblesAllRight()); sanity(asrtAllWatchedAlsoHooked()); asrt(asrtAllUnitsSent());

	restarts.nextStart();
	unlinked_clses.sort(ClActAscFunctor());

	while(restarts.shallRun()){

		asrt(decisionLevel()==0);
		LOG2(" main loop unlinked clauses " << unlinked_clses.size() <<" hooked: " << asrtGetHookedCount());

		if(unlinked_clses.empty()){		return TRUE_TrBool;}

		SharedClause* sat_next_cls		= unlinked_clses.back().first; unlinked_clses.pop_back();
										LOG3("New Round dmrp with cls with size");

		TrBool hooked					= tryToLinkAndHook(sat_next_cls);

		if(hooked.isFalse()){			return TrBool(setInvalid("Relinking unlinked clause"));}
		if(hooked.isTrue()){			continue;}

		TrBool status  					= dmrpSearchSatClause(sat_next_cls);

	    if(status.isFalse()){			return TrBool(setInvalid("When trying to modify reference point"));}

	    if(status.isUnknown()){

	    	LOG2("relink unlinked clauses" << unlinked_clses.size()); asrt(sat_next_cls->hasUser(sstate.s_info->user_bit));
	    	addClsUnlinked(sat_next_cls,false);
	    	backjumpKeepLevel(0); 		return status;} //max conflict limit reached

	    clearAssignsCareForHooks();
	    hooked 							= tryToLinkAndHook(sat_next_cls); asrt(hooked.isKnown());
	    if(hooked.isFalse()){			return TrBool(setInvalid("Relinking unlinked clause"));}
    }

	return UNKNOWN_TrBool;
}


bool	DMRPTrooper::containsHooked(SharedClause* cls){
	asrt(decisionLevel()==0);

	FOR_LITS_STRT(cls,c);
		if(	sstate.vinf.litTrue(c)
				||	(isRefPoint(c)&&sstate.vinf.litUkwn(c))) return true;

	FOR_LITS_END;

	return false;
}


TrBool	DMRPTrooper::tryToLinkAndHook(SharedClause* cls){
	asrt(decisionLevel()==0); asrt(asrtAllUnitsSent()); asrt(delta_stack.empty());
	Literal w1 		= FALSE_LIT;
	Literal w2 		= FALSE_LIT;
	Literal hook 	= FALSE_LIT;

	sendUnits();

	uint32_t csz	= 0;
	FOR_LITS_STRT(cls,lit);

		++csz;		asrt(lit.idx()<sstate.wtch.litsCount());

		if(sstate.vinf.litKnwn(lit)){
			if(sstate.vinf.litFalse(lit)){ 	continue;}
			SharedClause::release(cls,super::sstate.s_info->user_bit);
			return TRUE_TrBool;}

		w2=w1;
		w1=lit;
		if(	hook==FALSE_LIT &&
			isRefPoint(lit)){	hook = lit;}

		if(	w2	 !=FALSE_LIT &&
			hook !=FALSE_LIT){			csz=max32; break;}

	FOR_LITS_END;



	if(w1==FALSE_LIT)					return TrBool(setInvalid("When trying to link and hook"));
	if(w2==FALSE_LIT){
		asrt(sstate.vinf.litUkwn(w1));
		uint32_t qbeg				= queue_begin;
		if(	!enqueue(w1,0)||
			bcpLong()!=BCP_SUCCESS){	return TrBool(setInvalid("Bad unit when trying to link and hook"));}

		modifyHooksAt0(qbeg);
		return TRUE_TrBool;
	}
	if(hook == FALSE_LIT){				return UNKNOWN_TrBool;}

	LOG3(" found lits " << w1.toDIMACS() << " " << w2.toDIMACS() << " "<< hook.toDIMACS());
	asrt(sstate.vinf.litUkwn(w1));asrt(sstate.vinf.litUkwn(w2));asrt(sstate.vinf.litUkwn(hook));

	ClsPointer clp	= sstate.linkCls(cls,csz==max32 ? cls->countLits() : csz,w1,w2, UserMask(0));
	hook_resp		.add(hook.toVar(),clp);
	return			TRUE_TrBool;
}



TrBool DMRPTrooper::dmrpSearchSatClause(SharedClause* cls){
	asrt(decisionLevel()==0);	asrt(delta_stack.empty() ); sanity(asrtAllWatchedAlsoHooked());

	TrBool   result			= UNKNOWN_TrBool;
	deltaProbClausesEnsureLevel(0);
	addProbClsDelta(cls,0);

	uint32_t q_begin		= queue_begin;
	while(restarts.shallRun()){

    	int32_t bcp_res    	= bcpLong();

    	if(bcp_res == BCP_SUCCESS){         //there is no conflict

    		if(decisionLevel() != 0){

    		    assert(delta_stack.size() <= decisionLevel() + 1);

    		    deltaProbClausesEnsureLevel(decisionLevel());
    			updateDelta(q_begin);

    		}else {
    			LOG2(" modify hooks at 0");
    			modifyHooksAt0(q_begin); q_begin = queue_begin;

    			if(containsHooked(cls)){result = TRUE_TrBool; break;}
       		}

    		// New decision:
			Literal next    = nextDeltaDecision(); asrt(!openBCPImpls());

			//check if model is found
			if (next == INVALID_LIT){
				result =  TRUE_TrBool;
				break; }

            // Increase decision level and enqueue 'next'
            newDecisionLevel(); asrt(sstate.vinf.litUkwn(next));

            q_begin = queue_begin;
            if(!enqueue(next,decisionLevel())){
            	backjumpKeepLevel(0); LOG2("jump back immediatly at enqueue "<<next.toDIMACS());
            	restoreProbClsDelta();
            	q_begin = queue_begin;
            	if(!enqueue(next.flipped(),0)){result = TrBool(setInvalid("bad decision flip"));break;}
            }


    	}else{                         //there is a conflict

    		conflicts.incConflict();
    		LOG3("Prop caused "<<conflicts.count() <<". conflict at level " << decisionLevel());
    		q_begin	= handleConflictDMRP(bcp_res);
    		if(q_begin == max32){
    			result = TrBool(setInvalid("Conflict at level 0")); break;}

    		if(restarts.incConflictBreak(super::confl_levs)) break;
    	}
    }

	all_deltas		.clearAll();
	var_makes		.clearAllEles();
	delta_stack		.clear();
	delta_stack_idx	= 0;
	sendUnits();
	LOG2( " found mody with decisions " << decisionLevel());
	//print_out("return result %s \n",(result.isKnown()?(result.isTrue()?"true":"false"):"unknown"));
	return result;
}



uint32_t DMRPTrooper::handleConflictDMRP(int32_t bcp_res){

	if(decisionLevel() == 0) {asrt(bcp_res==0 || bcp_res==1);
		return max32;}

	LOG2("Start FUIP  with " << bcp_res << " lemma sz "<<lemma.size() << " at level " << decisionLevel()); asrt(otf_sub==NoOnTheFlySub); aux_var(bool lemma_in_db=)
	firstUIP(bcp_res); asrt(lemma.size()>0); asrt(!lemma_in_db);
	Literal watcher1	= lemma.back();	asrt(watcher1 != INVALID_LIT); asrt(sstate.vinf.litAssLev(watcher1) == decisionLevel());

	bumpGlueIf();

	LOG2("Lemma reduction");
	lemmaReduction(false);
	Literal watcher2; LOG2("determine bd level with lemma size " << lemma.size());
	uint32_t backtrack_level = backtrackLevel(watcher2);

/*
	uint32_t dist = decisionLevel()-backtrack_level;
	if(dist-- > 1){
		Literal aut_guess[dist];
		uint32_t dec = backtrack_level;
		for(uint32_t a=0;a!=dist;++a){ asrt(dec< decisionLevel());
			aut_guess[a] = assign_stack[decision_level_end[dec++]]; //decision dec+1
		}

		sstate.s_info->pushAutarkyGuess(aut_guess,dist);
	}
*/

	LOG2("Finally Backtrack to level " << backtrack_level);asrt(backtrack_level < decisionLevel());
	backjumpKeepLevel(backtrack_level);		asrt(sstate.vinf.litUkwn(watcher1) && decisionLevel() == backtrack_level);
	restoreProbClsDelta();
	uint32_t q_beg = queue_begin;

	LOG2("Learn lemma ");
	if(watcher2 == FALSE_LIT){
		LOG2("Resolved fixed literal: "<<watcher1.toDIMACS()); asrt(backtrack_level == 0);
		return enqueue(watcher1,0) ? q_beg : max32;
	}

	asrt(decisionLevel()>0);



	decision->decay();

	//add lemma
	if(currLemmaLong()){ asrt(watcher2 != FALSE_LIT); asrt(!lemma_in_db);
		asrt(lemma.size()> 2); asrt(confl_levs>0); asrt(sstate.vinf.litUkwn(watcher1)); asrt(sstate.vinf.litFalse(watcher2));

		SharedClause* cls	= SharedClause::construct(sstate.s_info->all_users_bits,lemma.begin(),lemma.end(),confl_levs,true);
		LOG2("Create new clause " << (uint64_t)cls << " as lemma" );	sanity(asrtClsUnit(cls,watcher1));
		conflicting 		= sstate.linkCls(cls,lemma.size(),watcher1,watcher2,UserMask(sstate.s_info->user_bit));

		clsHookNewLearnt(conflicting,cls,watcher1);
		confl_levs = cls->getOrigLBD();
		if(enqueue(watcher1,backtrack_level,conflicting,confl_levs)) return q_beg;

	}else{
		sstate.addBinAndSend(watcher1,watcher2);
		LOG2("Enqueue bin lit " << watcher1.toDIMACS() << " reason " << watcher2.toDIMACS()); asrt(!openBCPImpls());
		if(enqueue(watcher1,backtrack_level,watcher2)) return q_beg;
	}

	LOG2("Enqueue not immediately ok");
	backjumpKeepLevel(0);
	restoreProbClsDelta();
	q_beg = queue_begin;
	return !sstate.vinf.varKnwn(watcher1.toVar()) && enqueue(watcher1.flipped(),0) ? q_beg : max32;
}




void	DMRPTrooper::restoreProbClsDelta(){

	uint32_t start	= decisionLevel() + 1;	asrt(delta_stack.size() >= start);

	while(start < delta_stack.size()){
		all_deltas.invalidate(delta_stack[start++]);
	}

	deltaProbClausesEnsureLevel(decisionLevel());
}


void	DMRPTrooper::addProbClsDelta(const SharedClause* cls,const uint level){

	sanity(asrtAtLeastTwoUnassignedLits(cls,level));
	asrt(delta_stack.size() == decisionLevel()+ 1);

	const DCPtr& ld_ptr		= delta_stack[level];
	OneLevDeltaClses& ldcls	= all_deltas.getOneLev(ld_ptr); 	asrt(ldcls.isValid());
	const uint32_t dc_idx 	= ldcls.addClsGetIndex(cls);

	FOR_LITS_STRT(cls,lit);
		asrt(!sstate.vinf.litTrue(lit));

		if(sstate.vinf.litUkwn(lit) || sstate.vinf.litAssLev(lit) > level){
			asrt(!isRefPoint(lit));
			incrementMakeCount(lit,ld_ptr,dc_idx);}

	FOR_LITS_END;
}


void 	DMRPTrooper::modifyHooksAt0(uint32_t q_begin){
	asrt(decisionLevel()==0);asrt(queue_begin == assign_stack.size()); asrt(q_begin<=queue_begin);

	vector<std::pair<Literal,ClsPointer> > link_later;
	while(q_begin < queue_begin){
		const Literal true_lit			= assign_stack[q_begin++];

		if(isRefPoint(true_lit)){continue;}

		setRefPoint(true_lit);
		findNewHookResponsibles(true_lit.toVar(),link_later);
	}

	for(uint i = 0; i != link_later.size();++i){
		asrt(isRefPoint(link_later[i].first));
		hook_resp.add(link_later[i].first.toVar(),link_later[i].second);
	}
	sendUnits();
	sanity(asrtAllWatchedAlsoHooked());
}


void 	DMRPTrooper::updateDelta(uint32_t q_begin){

	const uint32_t dec_l = decisionLevel();
	ClsPointer clp; Literal cand;
	while(q_begin < assign_stack.size()){
		const Literal true_lit     = assign_stack[q_begin++];

		if(isRefPoint(true_lit)) continue;

		WIter<ClsPointer> iter = hook_resp.getWIter(true_lit.toVar());

	    while(iter.getNext(clp)){
	    	ClsWrp& cw			= sstate.cinf.get(clp);

	    	FOR_LITS_STRT(cw.getCls(),cand);
    			if(!sstate.vinf.litFalse(cand) && isRefPoint(cand)){
					hook_resp.add(cand.toVar(),clp);	goto CONTINUE_NEXT_CLS;}

				if(sstate.vinf.litTrue(cand)){
					iter.keep(clp);	goto CONTINUE_NEXT_CLS;}

			FOR_LITS_END;

	    	iter.keep(clp);
	    	addProbClsDelta(cw.getCls(),dec_l);

	    	CONTINUE_NEXT_CLS:;
	    }
	    hook_resp.finish(true_lit.toVar(),iter);
	 }
	//costly__assert(debugAllWatchedNonDeltaClausesHooked());
}



void  DMRPTrooper::clsHookNewLearnt(const ClsPointer& clp, const SharedClause* cls, const Literal& ass){
	asrt(cls==sstate.cinf.get(clp).getCls()); asrt(decisionLevel()!=0); asrt(sstate.vinf.litUkwn(ass));
	if(isRefPoint(ass)){
		hook_resp.add(ass.toVar(),clp);
		return;}

	//search deepest hooked lit that is assigned false or the asserting lit if hooked properly
	uint32_t level 			= 0;
	Literal take_response 	= INVALID_LIT;

	FOR_LITS_STRT(cls,cand);
		if(isRefPoint(cand) && sstate.vinf.litAssLev(cand)>level){ asrt(sstate.vinf.litFalse(cand));
			take_response	=cand;
			level			=sstate.vinf.litAssLev(cand);
		}

	FOR_LITS_END;

	asrt(take_response != INVALID_LIT);asrt(sstate.vinf.litKnwn(take_response));
	hook_resp.add(take_response.toVar(),clp);
	addProbClsDelta(cls,level);
}



Literal DMRPTrooper::nextDeltaDecision(){

	assert(delta_stack_idx <= delta_stack.size());
	vector<Literal> cands;

	while(delta_stack_idx--){

		const DCPtr& ldptr		= delta_stack[delta_stack_idx];
		OneLevDeltaClses& ldcls	= all_deltas.getOneLev(ldptr); asrt(ldcls.isValid());

		for(uint32_t lx = ldcls.size(); lx--;){
			DeltaClause& dcls 	= ldcls.getAt(lx);
			if(sstate.vinf.litTrue(dcls.getLiteral())) continue;

			const SharedClause* cls	= dcls.getClause();
			uint32_t cc				= collectPossibleDecLits(dcls,(SharedClause*)cls,cands);
			if(cc==0) continue;

			uint32_t mcount		= 0;
			act_t   max_act 	= act_t(0);

			if(!decision->timeForRandDecision()){

				const uint32_t end = cc; cc=0;
				std::sort(cands.begin(),cands.end(),MakeCountDescendingFunctor(this));

				for(uint i = 0; i < end;++i){
					Literal lit = cands[i];
					if(var_makes.sizeOf(lit.toVar()) < mcount) break; //since cands is sorted

					uint32_t cand 	= computeMakeCount(lit,mcount,cls);
					if(cand > mcount){
						mcount 		= cand;
						max_act		= decision->getAct(lit);
						cands[0]	= lit;
						cc			= 1;
					}else if(cand == mcount){

						act_t a 	= decision->getAct(lit);
						if(a > max_act){
							max_act 	= a;
							cands[0]	= lit;
							cc			= 1;
						}else if(a == max_act){
							cands[cc++]	= lit;
						}
					}
				}
			}
			asrt(cc > 0);
			Literal ret_lit = cc == 1 ? cands[0]: cands[decision->randInt(cc)];
			assert(ret_lit != INVALID_LIT);
			dcls.setLiteral(ret_lit);
			++delta_stack_idx;
			return ret_lit;
		}
	}

	return INVALID_LIT;
}


uint32_t   DMRPTrooper::collectPossibleDecLits(DeltaClause& dcls,SharedClause* cls,vector<Literal>& out){

	out.clear();

	FOR_LITS_STRT(cls,lit);
		if(sstate.vinf.litUkwn(lit)){asrt(!isRefPoint(lit));
			out.push_back(lit);
		}else if(sstate.vinf.litTrue(lit)){
			dcls.setLiteral(lit);
			return 0;
		}
	FOR_LITS_END;

	return out.size();
}





uint32_t DMRPTrooper::computeMakeCount(const Literal& lit, const uint32_t& lower_bound, const SharedClause* ommit){
	asrt(sstate.vinf.litUkwn(lit)); asrt(!isRefPoint(lit));

	uint32_t remain = var_makes.sizeOf(lit.toVar());
	if(remain < lower_bound){return 0;}

	WIter<MakeClause> iter		= var_makes.getWIter(lit.toVar());
	uint32_t mcount = 0;

	MakeClause mcls;
	while(iter.getNext(mcls)){
		if(remain-- + mcount < lower_bound){
			while(iter.getNext(mcls)){iter.keep(mcls);}
			break;
		}

		OneLevDeltaClses& dclses = all_deltas.getOneLev(mcls);
		if(!dclses.isValid()){continue;}
		iter.keep(mcls);

		DeltaClause& dcls = dclses.getAt(mcls.index_in_level);asrt(dcls.getClause() != NULL);

		if(dcls.getClause() != ommit && !sstate.vinf.litTrue(dcls.getLiteral())){

			Literal sat = checkSatByLit(dcls.getClause());
			if(sat == INVALID_LIT){	++mcount;}
			else{dcls.setLiteral(sat);}
		}
	}

	var_makes.finish(lit.toVar(),iter);
	return mcount;
}

uint32_t DMRPTrooper::asrtGetHookedCount() const {
	uint32_t h = 0;
	for(uint32_t i=nVars();i--;){
		h += hook_resp.sizeOf(Variable(i));}
	return h;
}

bool DMRPTrooper::asrtNumberHookResponsiblesAllRight()const{

	uint32_t h = asrtGetHookedCount();
	uint32_t c = sstate.stats->nAllLongClses();// - unlinked_clses.size();

	bool ok = h == c || (h+1) == c;
	if(!ok){
		ASRT_PRNT("Sum hooks resp: " <<  h << " sum linked cls: " << c<<endl);
	}
	return ok;
}

/*
bool DMRPTrooper::asrtAllFalse(const SharedClause* cls,const uint32_t end, const Literal& except){
	for(uint32_t i=0;i!= end;++i){
		Literal l = (*cls)[i];
		if(l != except && !sstate.vinf.litFalse(l)){
			ASRT_PRNT("Literal " << l.toDIMACS() <<" at pos " << i << " not false" );
			return false;
		}
	}
	return true;
}*/

bool DMRPTrooper::asrtAllWatchedAlsoHookedOf(const Literal& lit,uint32_t& count)const{
	Literal otherw; WtchEle we; uint32_t sz_dummy;
	Iter<WtchEle> wi	= sstate.wtch.getWtchOf(lit);

	while(wi.getNext(we)){
		ClsWrp cw			= sstate.cinf.getCopy(we.clp);
		Literal otherw 		= cw.getOtherW(lit); asrt(otherw!=lit);
		if(otherw<lit)  	continue;

		++count;
		SharedClause* cls = cw.getCls();

		Literal resp 	=	isRefPoint(lit) ? lit :
							(isRefPoint(otherw)?otherw:
							findHookRespons(cw.getCls(),sz_dummy));

		if(resp == INVALID_LIT){
			ASRT_PRNT("Linked Clause not hooked"<<endl);
			/*for(uint32_t k=0;k!=cls->size();++k){
				ASRT_PRNT("lit " << (*cls)[k].toDIMACS() << " lev " << ((sstate.vinf.litKnwn(l)) ? sstate.vinf.litAssLev(l) : -1 ) << endl);
			}*/
			cls->print();
			return false;
		}
	}
	return true;
}

bool DMRPTrooper::asrtAllWatchedAlsoHooked()const{
	asrt(decisionLevel()==0);asrt(beyUP_cands.empty());
	uint32_t count = 0;
	for(uint32_t w=0;w!=sstate.stats->nVariables(); ++w){
		const Variable v(w);
		if(sstate.vinf.varElim(v)|| sstate.vinf.varRepl(v)) continue;
		if(	!asrtAllWatchedAlsoHookedOf(v.toNegLit(),count) ||
			!asrtAllWatchedAlsoHookedOf(v.toPosLit(),count)) return false;
	}
	/*
	 * darf manchmal falsch sein
	 * uint32_t h = asrtGetHookedCount();
	if(count != h){
		ASRT_PRNT("Number of linked clses " << count << " number of hooked " << h);
		return false;
	}*/
	return true;
}


bool	DMRPTrooper::asrtAtLeastTwoUnassignedLits(const SharedClause* cls,uint level) const{

	uint32_t free = 0;

	FOR_LITS_STRT(cls,lit);
		if(sstate.vinf.litUkwn(lit) || sstate.vinf.litAssLev(lit) >= level){
			if(++free > 1) return true;
		}

	FOR_LITS_END;

	((SharedClause*)cls)->print();
	ASRT_PRNT(" at least two unassigned failed" <<endl);

	return false;
}

/*



void	DMRPTrooper::clearDeltaClausesAndMakeCount(){
	uw_clses_for_mc.invalidate();

	for(uint i = all_make_vars.size();i--;){
		Variable var = all_make_vars[i];
		var_makes[var.idx()].clear();
	}
	all_make_vars.clear();

	clearDeltaStack(0,true);
	delta_stack.clear();
	delta_stack_idx = 0;

	for(uint i = rubbish_level_delta_clauses.size();i--;){delete rubbish_level_delta_clauses[i];}
	rubbish_level_delta_clauses.clear();
	uw_clses_for_mc.reValidate();
}


bool	DMRPTrooper::removeRubbishMakeCounts(Variable var){

	vector<MakeClause>& make_cands = var_makes[var.idx()];
	uint32_t new_sz = make_cands.size();
	uint32_t idx = 0;

	while(idx < new_sz){
		MakeClause& mcls = make_cands[idx];

		if(mcls.level_clauses->isValid()){ ++idx;}
		else{ make_cands[idx] = make_cands[--new_sz];}
	}

	if(new_sz < make_cands.size()) make_cands.resize(new_sz);
	return new_sz != 0;
}


void 	DMRPTrooper::removeRubbishDeltaClauses(const bool clear_global){

	if(settings.global_make_count && clear_global) uw_clses_for_mc.invalidate();

	vector<Variable>::iterator from,to;
	for(from = to = all_make_vars.begin(); from !=  all_make_vars.end();++from){
		if(removeRubbishMakeCounts(*from)){*to++ = *from;}
	}
	if(to != all_make_vars.end()) all_make_vars.erase(to,all_make_vars.end());


	for(uint32_t i = rubbish_level_delta_clauses.size();i--;){
		assert(!rubbish_level_delta_clauses[i]->isValid());
		delete rubbish_level_delta_clauses[i];
	}
	rubbish_level_delta_clauses.clear();

	if(settings.global_make_count && clear_global) uw_clses_for_mc.reValidate();
}



void 	DMRPTrooper::updateDeltaCheckClause(cls_iter_t& from,cls_iter_t& copy){
	Clause& cl = **from++;

	Literal lit = cl[0];
	if(!litIsFalse(lit) && litIsHooked(lit)){litHookResponse(lit).push_back(&cl);return ;}
	if(litIsTrue(lit)){	*copy++ = &cl;return ;}

	lit = cl[1];
	if(!litIsFalse(lit) && litIsHooked(lit)){litHookResponse(lit).push_back(&cl);return ;}
	if(litIsTrue(lit)){	*copy++ = &cl;return ;}


	for(uint k = cl.getNextK(clause_stamp); k != cl.size(); ++k){
		lit = cl[k];
		if(!litIsFalse(lit) && litIsHooked(lit)){litHookResponse(lit).push_back(&cl);return ;}
		if(litIsTrue(lit)){	*copy++ = &cl;return ;}
	}
	*copy++ = &cl;
	addProbClsDelta(cl,decisionLevel());
}




















bool DMRPTrooper::clsLinkHook(Clause& cl){

	for(uint32_t lidx = 0; lidx != cl.size(); ++lidx) {
		assert(varHook(cl[lidx].toVar()) != UNKNOWN_TrBool);
		if(litIsHooked(cl[lidx]) && litIsNotFalse(cl[lidx])){
			litHookResponse(cl[lidx]).push_back(&cl);
			return true;
		}
	}

	//print_out("Keine Hooks f�r die%s Klausel: \n",(cl.isLearnt()?" gelernte":""));
	//cl.print(*settings.console_out);

	return false;
}


bool	DMRPTrooper::bcpDmrpOK(){

	assert(decisionLevel() 	== 0);
	assert(queue_begin 		<= assign_stack.size());
	uint32_t q_begin 		= queue_begin;

	if(bcp(RETURN) != BCP_SUCCESS){ return false;}

	unlinkUnhookedClauses(q_begin);
	costly__assert(debugNumberHookResponsiblesAllRight());

	return  true;
}



bool	DMRPTrooper::checkUnwatchedClauses(){


	costly__assert(debugNumberHookResponsiblesAllRight());

	assert(decisionLevel() == 0);

	removeRubbishDeltaClauses(true);

	uint32_t q_begin 		= queue_begin;
	const bool add_global 	= settings.global_make_count;

	do{
		costly__assert(debugNumberHookResponsiblesAllRight());

		state_ok = bcpDmrpOK();
		if(!state_ok){ return false;}

		q_begin = queue_begin;
		uwc_iter 	iter 	= unwatched_clauses.begin();

		while(iter != unwatched_clauses.end()){
			Clause* cls = *iter;
			if(checkSatByHook(*cls) != INVALID_LIT){
				warrant(clsReLink(cls,true));
				warrant(clsLinkHook(*cls));
				iter = unwatched_clauses.erase(iter);
				if(cls->isLearnt())	--nbr_learnt_uw_clses;
			}else{
				uint8_t valid_lits = clsValidLitsToFront(*cls);
				if(valid_lits == 0) return (state_ok = false);

				if(valid_lits == 1){
					assert(!litIsFalse((*cls)[0]));

					if(litIsUnknown((*cls)[0])){
						costly__assert(debugNumberHookResponsiblesAllRight());

						uncheckedEnqueue<Clause*>((*cls)[0]);
						state_ok = bcpDmrpOK();
						if(!state_ok) return false;
					}
					assert(litIsTrue((*cls)[0]));
				}

				//add to make counts
				if(add_global) {
					const uint32_t deltaClauseIndex = uw_clses_for_mc.addClauseGetIndex(cls);
					for(uint i = cls->size();i--;){			assert(!litIsTrue((*cls)[i]));
						if(litIsUnknown((*cls)[i])){		assert(!litIsHooked((*cls)[i]));
							incrementMakeCount((*cls)[i],&uw_clses_for_mc,deltaClauseIndex);}
					}
				}

				++iter;
			}

		}

	}while(q_begin != queue_begin);

	//print_out("Sum hooks resp: %d, sum linked cls: %d\n",sum_element_sizes(hooks_responses),(numberOfLongOrigClauses() + numberOfLongLearntClauses() - unwatched_clauses.size()));
	assert(debugNumberHookResponsiblesAllRight());

	//print_out("End check unwatched %d\n",unwatched_clauses.size());
	return true;
}
*/

/*
void	DMRPSolver::resetNormalClsState(){
	clause_stamp = 0;
	for(cls_iter_t iter = fix_cls.begin(); iter != fix_cls.end();++iter){(*iter)->clearStampAndFlag();}
	for(cls_iter_t iter = learnt_cls.begin(); iter != learnt_cls.end();++iter){(*iter)->clearStampAndFlag();}
}
*/

/*
uint	DMRPSolver::removeRubbishDeltaClauses(vector<DeltaClause*>& dclses,const bool del){
	vector<DeltaClause*>::iterator from,to,end;
	end = dclses.end();
	for(from = to = dclses.begin();from != end;++from){
		if(!(*from)->isRubbish()){*to++ = *from;}
		else if(del) {delete *from;}
	}
	if(to != end){dclses.erase(to,end);}
	return end - to;
}*/


/*


bool 	DMRPTrooper::relinkAllUnwatchedClauses(){

	assert(decisionLevel() == 0);
	//var_act_hp.decayAll();
	for(uwc_iter iter = unwatched_clauses.begin();iter!= unwatched_clauses.end();++iter){
		Clause* cls = *iter;
		if(!clsReLink(cls,false)) return state_ok = false;
		if(checkSatByHook(*cls) == INVALID_LIT){
			//print_out("Heavy Broken %s Clause: ",(cls->isLearnt()?"learnt":"original"));
			for(uint32_t i = cls->size(); i--;) {
				//print_out(" %d ",(*cls)[i].toDIMACS());
				varBump((*cls)[i].toVar());

				//debugPrintHookResponses((*cls)[i].flipped());

			}
			cls->setFilterFlag();
			//print_out("  \n");
		}
	}
	unwatched_clauses.clear();
	nbr_learnt_uw_clses = 0;
	return true;
}

bool	DMRPTrooper::clsPlaceValidLitToFront(Clause& cl, const uint32_t front,uint32_t& start){

	for(;start < cl.size();++start ){
		if(!litIsFalse(cl[start])){
			if(front != start){Literal t = cl[front];cl[front]=cl[start];cl[start]=t;}
			++start;
			return true;
		}
	}
	return false;
}

uint8_t DMRPTrooper::clsValidLitsToFront(Clause& cl){

	assert(decisionLevel() == 0);
	uint32_t k = 0;
	if(!clsPlaceValidLitToFront(cl,0,k))	return  0;

	if(!clsPlaceValidLitToFront(cl,1,k))	return 1;

	return 2;
}

bool    DMRPTrooper::clsReLink(Clause* cls,const bool care_for_hooks){

	assert(decisionLevel() == 0);

	//sort(cls->litsBegin(),cls->litsEnd(),LitActDescendingFunctor(this));

	uint8_t valid_lits = clsValidLitsToFront(*cls);
	if(valid_lits == 0) return state_ok = false;

	if(valid_lits == 1){
		assert(!litIsFalse((*cls)[0]));

		if(litIsUnknown((*cls)[0])){
			assert(state_ok);
			uncheckedEnqueue<Clause*>((*cls)[0]);

			if(care_for_hooks){
				costly__assert(debugNumberHookResponsiblesAllRight());
				state_ok = bcpDmrpOK();
			}else{
				state_ok = bcp(RETURN) == BCP_SUCCESS;
			}


			if(!state_ok){ return state_ok = false;}
		}
	}

	clsLinkWatched(cls);
	return true;
}

*/

/*
void DMRPTrooper::debugPrintHookResponses(const Literal& lit){

	DEBUG_FUNC
	vector<Clause*>& hr = litHookResponse(lit);

	print_out("Hook responsibles of Literal %d \n",lit.toDIMACS());
	for(uint i = hr.size();i--;){
		Clause* cl = hr[i];
		cl->print(*settings.console_out);
	}
	print_out("End \n");
}



bool	DMRPTrooper::debugNumberLearntUWClauseAllRight()  {

	DEBUG_FUNC
	uint32_t learntsc = 0;
	for(uwc_iter iter 	= unwatched_clauses.begin();  iter != unwatched_clauses.end(); ++iter){
		if((*iter)->isLearnt()) ++ learntsc;
	}
	return learntsc== nbr_learnt_uw_clses;
}




bool DMRPTrooper::debugAllHookResponsesCleared()const {
	DEBUG_FUNC
	for(uint i = hook_responses.size();i--;){
		if(!hook_responses[i].empty()) return false;
	}
	return true;
}


bool DMRPTrooper::debugAllDecCountsZero()const {
	DEBUG_FUNC
	for(uint i = dec_var_count.size();i--;){
		if(dec_var_count[i] != 0 ) return false;
	}
	return true;
}






bool DMRPTrooper::debugOneLitIsHookedForWatchedClauses(vector<Clause*>& clauses, Clause* except)const{

	DEBUG_FUNC
	for(uint32_t idx = 0;idx != clauses.size(); ++idx){
		Clause* cls = clauses[idx];
		if(cls->isRubbish() || cls == except) continue;
		if(cls->isWatched() && !debugOneLitIsHookedOrTrue(*cls)) return false;
	}
	return true;
}

bool DMRPTrooper::debugClsIsInDelta(Clause* cls) const{
	DEBUG_FUNC
	for(uint outer = 0; outer != delta_stack.size();++outer){
		OneLevelDeltaClauses* d_cls = delta_stack[outer];

		for(delta_iter iter = d_cls->deltasBegin(); iter != d_cls->deltasEnd() ;++iter){
			if(iter->getClause() == cls) return true;
		}
	}
	return false;
}


bool DMRPTrooper::debugAllWatchedNonDeltaClausesHooked() const{

	DEBUG_FUNC
	for(uint32_t idx = 0;idx != fix_cls.size(); ++idx){
		Clause* cls = fix_cls[idx];
		if(cls->isRubbish()) continue;
		if(cls->isWatched() && !debugClsIsInDelta(cls) && !debugOneLitIsHookedOrTrue(*cls))
				return false;
	}

	return true;
}


bool DMRPTrooper::debugOneLitIsHookedOrTrue(Clause& cl) const {
	//DEBUG_FUNC
	for(uint i = 0; i != cl.size(); ++i){
		Literal lit = cl[i];
		if(litIsTrue(lit)) return true;
		if(litIsHooked(lit) && litIsNotFalse(lit)){ return true;}
	}


	print_out("Clause is not hooked @ level %d \n",decisionLevel());
	Literal resp_cand = INVALID_LIT;

	for(uint i = 0; i != cl.size(); ++i){
		Literal lit = cl[i];

		print_out("Literal %d at level %d has value %s and var hook %s \n",lit.toDIMACS(),litAssignLevel(lit),
				(litIsUnknown(lit)?"unknown":(litIsTrue(lit)?"true":"false")),
				(varHook(lit.toVar()).isUnknown()?"unknown":(varHook(lit.toVar()).isTrue()?"true":"false")));
		if(litIsHooked(lit)){
			const vector<Clause*>& hr = hook_responses[lit.toVar().idx()];
			if(find(hr,ClauseEqualFunc(&cl))){resp_cand = lit;	}
		}
	}
	print_out("Clause is%s watched marked and%s learnt \n",(cl.isWatched()?"":" not"),(cl.isLearnt()?"":" not"));
	print_out("Candidate was: ");
	if(resp_cand != INVALID_LIT) print_out("Literal: %d \n", resp_cand.toDIMACS());
	else print_out("none\n");



	return false;
}

bool DMRPTrooper::debugOneLitIsResponsibleForClause(Clause& cl) const{

	DEBUG_FUNC
	for(uint i = 0; i != cl.size(); ++i){
		Literal lit = cl[i];
		if(litIsHooked(lit) && litIsNotFalse(lit)){
			const vector<Clause*>& hr = hook_responses[lit.toVar().idx()];
			if(find(hr,ClauseEqualFunc(&cl))) return true;
		}
	}
	if(settings.console_out != NULL){
		print_out("Nobody responsible for: \n");
		cl.print(*settings.console_out);
		print_out("Clause is%s learnt \n",(cl.isLearnt()?"":" not"));
		print_out("Candidate was: \n");
		for(uint i = 0; i != cl.size(); ++i){
			Literal lit = cl[i];
			if(litIsHooked(lit)){
				const vector<Clause*>& hr = hook_responses[lit.toVar().idx()];
				if(find(hr,ClauseEqualFunc(&cl))){
					print_out("Literal: %d at decision level %d \n", lit.toDIMACS(), litAssignLevel(lit));
					return false;
				}
			}
		}
		print_out("none\n");
	}


	return false;
}


*/



const char*  dmrptrooper_cpp_version(){return "DMRPSolver.cpp:     $Revision: 1.18 $";}

