
#ifndef SATISTICS_HPP_
#define SATISTICS_HPP_
#define satistics_hpp_version      "$Revision: 1.4 $"

#include "GlobalSettings.hpp"
#include "SharedBasic.hpp"
#include "AtomicTypes.hpp"



using std::string; using std::cout; using std::endl;

//#define STATS_EXP_TIME 1



//#define SATISTICSTEMP template<class Conflicts>
#define SATISTICSCLASS Satistics


class Satistics{
	template<class CP>
	inline void printStats(const std::string& result, CP& p,const bool print_shared,const UserID& solver);
	static const uint32_t 	TH_WIDTH_PARA_ST	= 12;
	static const uint32_t 	TH_WIDTH_PARA_PROP	= 18;
	static const uint32_t 	TH_WIDTH_PARA_PRE 	= 30;

public:
	uint64_t				nbr_confl;
	uint32_t				nbr_vars;
	uint32_t				nbr_bin_clses;
	//uint32_t				nbr_tern_clses;
	uint32_t				nbr_ll_cls;
	uint32_t				nbr_lf_cls;
	uint64_t				nbr_ll_lits;
	uint64_t				nbr_lf_lits;
	uint32_t				nbr_var_repl;
	uint32_t				nbr_var_elim;
	uint32_t				nbr_comp_bcp_unit;
	uint32_t				nbr_comp_bcp_bin;
	uint32_t				nbr_comp_bcp_long;
	uint32_t				nbr_comp_selfsub;
	uint32_t				nbr_comp_bcp_cheap_fail;
	uint32_t				nbr_comp_bcp_exp_fail;
	uint32_t				nbr_hyper_bin_res;
	uint32_t				nbr_hyper_bin_self_sub;
	uint32_t				nbr_hyper_bin_lemma_red;
	//uint32_t				nbr_hyper_bin_impr;
	uint32_t				nbr_scc_exec;
	uint32_t				nbr_scc_units;
	uint32_t				nbr_scc_shortcuts;
	uint32_t				nbr_assym_chk;
	uint32_t				assym_shrnk_easy;
	uint32_t				assym_subsum_easy;
	uint32_t				assym_lits_rem;

	//uint32_t				nbr_autarkies;
	//uint32_t				nbr_matrix_exec;
	uint32_t				nbr_cls_subsume;
	uint32_t				nbr_cls_bin_subsume;
	uint32_t				nbr_lits_subsume;
	uint32_t				max_dec_level;
	uint64_t				nbr_starts;
	uint64_t				nbr_imports;
	uint64_t				nbr_bcp;
	double					bcp_time;
	double					bcp_comp_time;
	double					bcktrk_time;
	uint64_t				sum_bcktrk;
	uint64_t				nbr_act_dec;
	uint64_t				nbr_rand_dec;
	double					decision_time;
	uint32_t				nbr_gc;
	uint32_t				nbr_panic;
	double					gc_time;
	uint32_t				nbr_simplify;
	double					simp_time;
	double					graph_ana_time;
	double					remove_fix_verts_time;
	double					import_shrt_time;
	double					import_long_time;
	uint64_t				nbr_lemma_reduct;
	uint64_t				nbr_lemma_reduct_shrts;
	uint32_t				bin_impl;
	double					init_time;

	Satistics():
		nbr_confl					(0),
		nbr_vars					(0),
		nbr_bin_clses				(0),
		//nbr_tern_clses				(0),
		nbr_ll_cls					(0),
		nbr_lf_cls					(0),
		nbr_ll_lits					(0),
		nbr_lf_lits					(0),
		nbr_var_repl 				(0),
		nbr_var_elim 				(0),
		nbr_comp_bcp_unit			(0),
		nbr_comp_bcp_bin			(0),
		nbr_comp_bcp_long			(0),
		nbr_comp_selfsub			(0),
		nbr_comp_bcp_cheap_fail		(0),
		nbr_comp_bcp_exp_fail		(0),
		nbr_hyper_bin_res			(0),
		nbr_hyper_bin_self_sub		(0),
		nbr_hyper_bin_lemma_red		(0),
		//nbr_hyper_bin_impr			(0),
		nbr_scc_exec				(0),
		nbr_scc_units				(0),
		nbr_scc_shortcuts			(0),
		nbr_assym_chk				(0),
		assym_shrnk_easy			(0),
		assym_subsum_easy			(0),
		assym_lits_rem				(0),

		//nbr_autarkies				(0),
		//nbr_matrix_exec				(0),
		nbr_cls_subsume				(0),
		nbr_cls_bin_subsume			(0),
		nbr_lits_subsume			(0),
		max_dec_level				( 0 ),
		nbr_starts					( 0 ),
		nbr_imports					( 0),
		nbr_bcp						( 0 ),
		bcp_time 					( 0 ),
		bcp_comp_time				( 0 ),
		bcktrk_time					( 0 ),
		sum_bcktrk					( 0 ),
		nbr_act_dec					( 0 ),
		nbr_rand_dec				( 0 ),
		decision_time				( 0 ),
		nbr_gc						( 0 ),
		nbr_panic					( 0 ),
		gc_time						( 0 ),
		nbr_simplify				( 0 ),
		simp_time					( 0 ),
		graph_ana_time				( 0 ),
		remove_fix_verts_time		( 0 ),
		import_shrt_time			( 0 ),
		import_long_time			( 0 ),
		nbr_lemma_reduct			( 0 ),
		nbr_lemma_reduct_shrts		( 0 ),
		bin_impl					( 0 ),
		init_time					( 0 )
		{}

	inline void printProgress(uint32_t conflicts);
	static inline void printParaHead(uint32_t nbr_threads);
	inline void printParaProgress(const bool first, const bool last);

	inline void printCSV(std::string file_name, TrBool result);
	inline void printStatsOneThread(const UserID& uid, TrBool result,const uint32_t nbr_threads);
	static inline void printStatsConsole(const vector<Satistics*> stats, const UserID& solvers_id, TrBool result);
	static inline void printCSV(std::string file_name,const vector<Satistics*> stats,const UserID& solvers_id,TrBool result);


	uint64_t nLitsInLongLearntClses()	const	{return nbr_ll_lits;}
	uint64_t nLitsInLongFixClses()		const	{return nbr_lf_lits;}
	uint64_t nLitsInLongClses()			const	{return nLitsInLongLearntClses()+nLitsInLongFixClses();}
	//uint64_t nLitsInTernClses()			const	{return nbr_tern_clses*3;}
	uint64_t nLitsInBinClses()			const	{return nbr_bin_clses << 1;}
	uint64_t nLits()					const	{return nLitsInLongClses() + nLitsInBinClses();}

	uint32_t nVariables()				const	{return nbr_vars;}
	uint32_t nBinClses()				const	{return nbr_bin_clses;}
	//uint32_t nTernClses()				const	{return nbr_tern_clses;}
	uint32_t nLearntLongClses()			const	{return nbr_ll_cls;}
	uint32_t nOrigLongClses()			const	{return nbr_lf_cls;}
	uint32_t nAllLongClses()			const	{return nOrigLongClses() + nLearntLongClses();}
	uint32_t nAllClauses()				const	{return nAllLongClses() + nBinClses();}

	//Conflicts& getConflictCount()				{return conflict_info;}
	static const double WTIME_START;
	static inline double cpuWallTime();
};


double Satistics::cpuWallTime(){
	return omp_get_wtime() - WTIME_START;
};



#ifdef STATS_EXP_TIME
#define TIME_ON(what)  	what -= Satistics::cpuWallTime()
#define TIME_OFF(what)  what += Satistics::cpuWallTime()
#else
#define TIME_ON(what)  	asrt(true)
#define TIME_OFF(what)  asrt(true)
#endif


inline uint64_t usedMemoryBytes(){
    char    path[256];
    sprintf(path, "/proc/%d/statm", getpid());
    FILE*   in = fopen(path, "rb");
    if (in == NULL) return 0;
    uint64_t     value;
# if __WORDSIZE == 64
    if(!fscanf(in, "%ld", &value)){value = 0;}
#else
    if(!fscanf(in, "%lld", &value)){value = 0;}
#endif
    fclose(in);
    return value * (uint64_t)getpagesize();
};




inline std::string toString(double d){
	static char buff[30];
	sprintf(buff," %*.3f ",13,d);
	return std::string(buff);
}

inline std::string toString(uint64_t l){
	static char buff[30];

# if __WORDSIZE == 64
	sprintf(buff," %13lu ",l);
#else
    sprintf(buff," %13llu ",l);
#endif

	return std::string(buff);
}

inline std::string toString(uint32_t i){
	static char buff[30];
	sprintf(buff," %13u ",i);
	return std::string(buff);
}


inline std::string toString(int i){
	static char buff[30];
	sprintf(buff," %13i ",i);
	return std::string(buff);
}

inline std::string toString(const std::string& s){
	if(s.size()>= 15) return s;
	std::string ret = "                " + s;
	return ret.substr(ret.size()-15,15);
}


void SATISTICSCLASS::printParaHead(uint32_t nbr_threads){

	cout << endl;
	const uint32_t width 	= (TH_WIDTH_PARA_ST+TH_WIDTH_PARA_PROP) * nbr_threads + TH_WIDTH_PARA_PRE + 2;
	static char buff[3];
	sprintf(buff,"%2u",nbr_threads);
	string banner= "SArTagnan ... YOU GOT ME SEARCHING [" + string(buff) + "] Threads";
	banner += string((width-banner.size()-1)/2,' ') + "||";


	cout << "||" << std::setw(width-2) << std::setfill('#') << "||" << endl;

	cout << "||" << std::setw(width-2) << std::setfill(' ') << std::right << banner << endl;

	cout << "||" << std::setw(width-2) << std::setfill('-') << "||" << endl;

	cout 	<< std::setfill(' ') << std::internal
			<< "||"	<< std::setw(TH_WIDTH_PARA_PRE-2) 	<< "General                 ";
	for(uint32_t i = 0;i!= nbr_threads;++i){
		cout<< "||"	<< std::setw(TH_WIDTH_PARA_ST+TH_WIDTH_PARA_PROP-13) 	<< "Thread" << std::setw(3) << i << "        ";}
	cout 	<< "||"	<< endl;

	cout 	<< std::setfill(' ') << std::internal
			//<< "||"	<< std::setw((TH_WIDTH_PARA_PRE/3) - 2) 	<< "UTime [s]  "
			<< "||"	<< std::setw((TH_WIDTH_PARA_PRE/2) - 2) 	<< "WTime [s]  "
			<< "|"	<< std::setw((TH_WIDTH_PARA_PRE/2) - 1) 	<< "Mem [MB]   ";
	for(uint32_t i = 0;i!= nbr_threads;++i){
		cout<< "||"	<< std::setw(TH_WIDTH_PARA_ST - 2) 	<< "Starts   ";
		cout<< "|"	<< std::setw(TH_WIDTH_PARA_PROP - 1) 	<< "Props   ";}
	cout << "||"	<< endl;

	cout << "||" << std::setw(width-2) << std::setfill('-') << "||" << endl;
	cout << std::setfill(' ');
}


void SATISTICSCLASS::printParaProgress(const bool first, const bool last){
	if(first){
		cout.setf(std::ios::fixed,std::ios::floatfield);
		cout.precision(2);
		double  used_bytes = (double)usedMemoryBytes()/(double)MEGA;
		cout
			//<< "||"	<< std::setw((TH_WIDTH_PARA_PRE/3) - 2) 	<< cpuUsrTime()
			<< "||"	<< std::setw((TH_WIDTH_PARA_PRE/2) - 2) 	<< cpuWallTime()
			<< "|"	<< std::setw((TH_WIDTH_PARA_PRE/2) - 1) 	<< used_bytes;
	}

		cout<< "||"	<< std::setw(TH_WIDTH_PARA_ST - 2) 	<< nbr_starts
			<< "|"	<< std::setw(TH_WIDTH_PARA_PROP - 1) 	<< nbr_bcp;
	if(last){cout<< "||"<< endl;}
}




struct CSVPrinter{
	std::ofstream& out;
	std::string values;
	CSVPrinter(std::ofstream& o):out(o){}
	void head(const std::string& s)	{out << std::setw(15) << s << " & ";}
	void val(const std::string& s)	{values += s + " & ";}
	void skipLines(uint32_t l)		{};
	void finish(){
		time_t rawtime; time(&rawtime); struct tm* timeinfo = localtime(&rawtime);
		char* date_time = asctime(timeinfo); *(date_time + strlen(date_time) - 1) = ' ';
		head("Date"); 	val(std::string(" \"" + std::string(date_time) + "\" "));
		head("END"); 	val("END");
		out <<  endl << values << endl;}
};

struct ConsolePrinter{
	const uint32_t width;
	ConsolePrinter(uint32_t w):width(w-41){asrt(w>41);}
	void head(const std::string& s)	{cout << "||" << std::setw(25) << s << ":";}
	void val(const std::string& s) 	{cout << std::setw(15) << s << std::setw(width) << "||" << endl;}
	void finish()					{};
	void skipLines(uint32_t l)		{};
};

struct StatsCollector{
	int32_t curr_l;
	bool silent;
	vector<vector<string> > lines;
	StatsCollector():curr_l(-1),silent(true){}
	void reset(bool slnt){curr_l=-1;silent=slnt;}
	void skipLines(uint32_t l){curr_l+=l;}
	void head(const std::string& s)	{
		if(++curr_l >= (int32_t)lines.size()){
			lines.push_back(vector<string>(1,s)); asrt(curr_l<(int32_t)lines.size());}}
	void val(const std::string& s) 	{asrt(curr_l<(int32_t)lines.size());lines[curr_l].push_back(s);}
};

struct ThreadsConsolePrinter: public StatsCollector{
	const uint32_t width;
	ThreadsConsolePrinter(uint32_t w):StatsCollector(),width(w-1){}
	void finish(){if(silent) return;
		for(uint32_t i=0;i!=lines.size();++i){
			cout << "||" << std::setw(25) << lines[i][0] << ":";
			uint32_t w = width -25;
			for(uint32_t j=1;j<lines[i].size();++j){
				w-= 15;
				cout << std::setw(15) << lines[i][j];}
			cout << std::setw(w) << "||" << endl;
		}
	};
};

struct ThreadsCSVPrinter: public StatsCollector{
	std::ofstream& out;
	ThreadsCSVPrinter(std::ofstream& o):StatsCollector(),out(o){}
	void finish(){if(silent) return;
		for(uint32_t i=0;i!=lines.size();++i){
			const string s 		= lines[i][0];
			const uint32_t vals = lines[i].size()-1; asrt(vals>0);
			if(vals==1){out << s << " & "; continue;}
			for(uint32_t j=0;j!=vals;++j){
				out << s << " (T"<< j<< ")& ";}
		}

		out << "Date" << " & END" << endl;

		for(uint32_t i=0;i!=lines.size();++i){
			for(uint32_t j=1;j!=lines[i].size();++j){
				out << lines[i][j] << " & ";}
		}

		time_t rawtime; time(&rawtime); struct tm* timeinfo = localtime(&rawtime);
		char* date_time = asctime(timeinfo); *(date_time + strlen(date_time) - 1) = ' ';
		out << std::string(" \"" + std::string(date_time) + "\" ") << " & END" << endl;
	}
};



void 	SATISTICSCLASS::printCSV(std::string file_name, TrBool result){
	asrt(!file_name.empty());
	string res			= (result.isKnown() ? (result.isTrue()?"SAT":"UNSAT") : "UNKNOWN");
	res += "               ";
	std::ofstream out(file_name.c_str());
	CSVPrinter printer(out);
	printStats(res,printer,true,UserID(0));
}


void 	SATISTICSCLASS::printStatsOneThread(const UserID& uid, TrBool result,const uint32_t nbr_threads){
	string res			= result.isKnown() ? (result.isTrue()?"SAT ":"UNSAT ") : "UNKNOWN ";
	const uint32_t width 	= (TH_WIDTH_PARA_ST+TH_WIDTH_PARA_PROP) * nbr_threads + TH_WIDTH_PARA_PRE;
	cout << "||" << std::setw(width) << std::setfill('-') << "||" << endl;
	cout << std::setfill(' ');
	ConsolePrinter printer(width);
	printStats(res,printer,true,uid);
	cout << "||" << std::setw(width) << std::setfill('#') << "||" << endl;
	cout << std::setfill(' ');
}

#define VALUE(x) p.val(toString(x))

void SATISTICSCLASS::printStatsConsole(const vector<Satistics*> stats, const UserID& solvers_id, TrBool result){
	string res				= result.isKnown() ? (result.isTrue()?"SAT/ ":"UNSAT/ ") : "UNKNOWN/ ";
	const uint32_t width 	= (TH_WIDTH_PARA_ST+TH_WIDTH_PARA_PROP) * stats.size() + TH_WIDTH_PARA_PRE;
	cout << "||" << std::setw(width) << std::setfill('-') << "||" << endl;
	cout << std::setfill(' ');
	ThreadsConsolePrinter p(width);
	for(uint32_t i=0;i!=stats.size();++i){
		p			.reset(i+1!=stats.size());
		stats[i]	->printStats(res,p,i==0,solvers_id);
	}
	cout << "||" << std::setw(width) << std::setfill('#') << "||" << endl;
	cout << std::setfill(' ');
}

void SATISTICSCLASS::printCSV(std::string file_name,const vector<Satistics*> stats,const UserID& solvers_id,TrBool result){
	asrt(!file_name.empty());
	string res			= (result.isKnown() ? (result.isTrue()?"SAT":"UNSAT") : "UNKNOWN");
	res += "               ";
	std::ofstream out(file_name.c_str());
	ThreadsCSVPrinter p(out);
	for(uint32_t i=0;i!=stats.size();++i){
		p			.reset(i+1!=stats.size());
		stats[i]	->printStats(res,p,i==0,solvers_id);
	}
}

#define a_per_b(x,t) 	((t)==0?0.0:((double)(x)/(double)(t)))
#define perc(x)	a_per_b	((x*100.0),timestmp)
template<class CP>
void SATISTICSCLASS::printStats(const std::string& result, CP& p,const bool print_shared,const UserID& solver){

	double  timestmp 		= cpuWallTime();

    std::string values  = "";
    if(print_shared){
    p.head("User Time [s]");		VALUE(cpuUsrTime());
    p.head("System Time [s]");		VALUE(cpuSysTime());
    p.head("Memory [MB]");			VALUE((double)usedMemoryBytes() / (double)MEGA);
    p.head("Solving Thread");		VALUE((uint32_t)solver.id);
    p.head("Result");				VALUE(result);} else{ p.skipLines(5);}
    p.head("Wtime [s]");			VALUE(timestmp);
    p.head("Init Time [s]");		VALUE(init_time);

    p.head("Variables");			VALUE(nVariables());
    p.head("Bin Clauses");			VALUE(nBinClses());
//  p.head("Tern Clauses");			VALUE(nTernClses());
    p.head("Orig Clauses");			VALUE(nOrigLongClses());
    p.head("Long Learnts");			VALUE(nLearntLongClses());
    p.head("Literals");				VALUE(nLits());

    p.head("Starts");				VALUE(nbr_starts);
    p.head("Propagations");			VALUE(nbr_bcp);
    p.head("Props/Decision");		VALUE(a_per_b(nbr_bcp,nbr_act_dec+nbr_rand_dec));
    p.head("Conflicts");			VALUE(nbr_confl);
    p.head("Sum Backtrack");		VALUE(sum_bcktrk);
    p.head("Backtrack per Confl");	VALUE(a_per_b(sum_bcktrk,nbr_confl));
    p.head("Act Decisions");		VALUE(nbr_act_dec);
    p.head("Rand Decisions");		VALUE(nbr_rand_dec);
    p.head("Max Dec Level");		VALUE(max_dec_level);
	p.head("GC");					VALUE(nbr_gc);
	//p.head("Panic GC");				VALUE(nbr_panic);
	p.head("Imports");				VALUE(nbr_imports);
	p.head("Simplify");				VALUE(nbr_simplify);
	//p.head("Bin impls unit");		VALUE(bin_impl);
    p.head("Lemma Reduct");			VALUE(nbr_lemma_reduct);
    //p.head("Lemma Red Shrt");		VALUE(nbr_lemma_reduct_shrts);
    p.head("Clses subsumed by long");VALUE(nbr_cls_subsume);
    p.head("Clses subsumed by bin");VALUE(nbr_cls_bin_subsume);
    p.head("Remove lits bw-sub.");	VALUE(nbr_lits_subsume);

    p.head("Replaced vars");		VALUE(nbr_var_repl);
    p.head("Eliminated vars");		VALUE(nbr_var_elim);
    p.head("Comp BCP Unit");		VALUE(nbr_comp_bcp_unit);
    p.head("Comp BCP Bin");			VALUE(nbr_comp_bcp_bin);
    p.head("Comp BCP Long");		VALUE(nbr_comp_bcp_long);
    p.head("Comp saves Decisions");	VALUE(100.0*((double)nbr_comp_bcp_long+nbr_comp_bcp_unit+nbr_comp_bcp_bin)/((double)nbr_act_dec+nbr_rand_dec));
    p.head("Comp BCP Selfsubsume");	VALUE(nbr_comp_selfsub);
    p.head("Comp BCP Chp Fail");	VALUE(nbr_comp_bcp_cheap_fail);
    p.head("Comp BCP Exp Fail");	VALUE(nbr_comp_bcp_exp_fail);
    p.head("SCC calls");			VALUE(nbr_scc_exec);
    p.head("SCC units");			VALUE(nbr_scc_units);
    p.head("SCC shortcuts");		VALUE(nbr_scc_shortcuts);

    p.head("Assym Checks");			VALUE(nbr_assym_chk);
    p.head("Assym Easy Shrink");	VALUE(assym_shrnk_easy);
    p.head("Assym Easy Subsum");	VALUE(assym_subsum_easy);
    p.head("Assym Lits Removed");	VALUE(assym_lits_rem);
    //p.head("Assym Lits Heavy");		VALUE(assym_shrnk_ana);





    //p.head("Found autarkies");		VALUE(nbr_autarkies);


    p.head("Hyper-Bin Res");		VALUE(nbr_hyper_bin_res);
    p.head("Hyper-Bin Self Sub");	VALUE(nbr_hyper_bin_self_sub);
    p.head("Hyper-Bin Lemma Red");	VALUE(nbr_hyper_bin_lemma_red);
    //p.head("Hyper-Bin Improve");	VALUE(nbr_hyper_bin_impr);


#ifdef STATS_EXP_TIME
    p.head("Expensive Profiling");	VALUE("---");
    p.head("Props Time [s]");		VALUE(bcp_time);
    p.head("Props Percent");		VALUE(perc(bcp_time));
    p.head("Props Comp Time [s]");	VALUE(bcp_comp_time);
    p.head("Props Comp Percent");	VALUE(perc(bcp_comp_time));
    p.head("Props per sec");		VALUE(a_per_b(nbr_bcp,bcp_time));
    p.head("Backtrack Time [s]");	VALUE(bcktrk_time);
    p.head("Backtrack Percent");	VALUE(perc(bcktrk_time));
    p.head("Backtracks per sec");	VALUE(a_per_b(sum_bcktrk,bcktrk_time));
    p.head("Decisions Time [s]");	VALUE(decision_time);
    p.head("Decision Percent");		VALUE(perc(decision_time));
    p.head("Decisions per sec");	VALUE(a_per_b(nbr_act_dec+nbr_rand_dec,decision_time));
    p.head("GC Time [s]");			VALUE(gc_time);
    p.head("GC Percent");			VALUE(perc(gc_time));
    p.head("Simplify Time [s]");	VALUE(simp_time);
    p.head("Simplify Percent");		VALUE(perc(simp_time));
    p.head("Graph Analysis [s]");	VALUE(graph_ana_time);
    p.head("Graph Ana Percent");	VALUE(perc(graph_ana_time));
    p.head("Clean Comps [s]");		VALUE(remove_fix_verts_time);
    p.head("Clean Comps Percent");	VALUE(perc(remove_fix_verts_time));

    p.head("Import Shorts [s]");	VALUE(import_shrt_time);
    p.head("Import Shorst Perc.");	VALUE(perc(import_shrt_time));
    p.head("Import Longs [s]");		VALUE(import_long_time);
    p.head("Import Longs Perc.");	VALUE(perc(import_long_time));

#endif
    //p.head("Max Active Vars");		VALUE(var_act_hp.active_count);
    //p.head("Act Vars Percent");		VALUE(((double)var_act_hp.active_count*100.0)/((double)nVariables()));

    p.finish();
}




#endif /* SATISTICS_HPP_ */
